* ------------------------------------------------------------
*    Tonkyun Panic Library
*     tonpani
*                                             (C)1995 nenetto
* ------------------------------------------------------------
*
RCSID:		.dc.b	'@(#)$Id: _pcm.s,v 1.5 1995-03-20 16:57:53+0900 nenetto Exp $',0
		.even

		.xdef	_pcm_play
		.xdef	_pcm_stop
		.xdef	_pcm_loop_stop
		.xdef	_mercury_check


* ------------------------------------------------------------
*	PCMĐ
*
*	input	d0.l : data address
*		d1.l : data length
*		d7.l : loop mode*$1000000 +pcm type*$10000 +pcm rate*$100 +panpot
*	output	d7.l : error status


*
*	loop mode.. 0:not loop
*		    1:loop
*
*	pcm type... 0: ADPCM
*		    1: 8bit PCM mono
*		    2: 8bit PCM stereo
*		    3:16bit PCM mono
*		    4:16bit PCM stereo
*
*	pcm rate... 0: 3.9 /16 kHz (ADPCM /PCM)
*		    1: 5.2 /22 kHz
*		    2: 7.8 /24 kHz
*		    3:10.4 /32 kHz
*		    4:15.6 /44 kHz
*		    5:---- /48 kHz
*
*	panpot...   0:----
*		    1:  L ch
*		    2:  R ch
*		    3:L+R ch


*	`V3.1
*	  8bit 16 /22 /24 /32 /44 /48  16bit 16 /22 /24 /32 /44 /48
*	        Y   Y   Y   v   v   v         V   V   V   |   |   |
*	 16bit 32 /44 /48 /32 /44 /48  16bit 32 /44 /48 /32 /44 /48
*
*	V3.5`
*	  8bit 16 /22 /24 /32 /44 /48  16bit 16 /22 /24 /32 /44 /48
*	        v   v   v   v   v   v         |   |   |   |   |   |
*	 16bit 16 /22 /24 /32 /44 /48  16bit 16 /22 /24 /32 /44 /48
*
*	V4`
*	  8bit 16 /22 /24 /32 /44 /48  16bit 16 /22 /24 /32 /44 /48
*	        |   |   |   |   |   |         |   |   |   |   |   |
*	  8bit 16 /22 /24 /32 /44 /48  16bit 16 /22 /24 /32 /44 /48



DMAC_CH2	equ	$e84080
DMAC_CH3	equ	$e840c0
MERCURY_DATA	equ	$ecc080
MERCURY_COMMAND	equ	$ecc091
MERCURY_STATUS	equ	$ecc0a1


		.offset	0
P_ex_buff:	.ds.l	1
P_last_data:	.ds.l	1
Db_last_type:	.ds.b	1
Db_last_rate:	.ds.b	1
P_data:		.ds.l	1	
D_length:	.ds.l	1	
Db_loop:	.ds.b	1	
Db_type:	.ds.b	1	
Db_rate:	.ds.b	1	
Db_pan:		.ds.b	1	
buffer_length:
		.text

B_buff:		.dcb.b	buffer_length,0

_pcm_play:
		movem.l	d0-d6/a0-a6,-(sp)
	
		lea	B_buff(pc),a6
		movem.l	d0-d1/d7,P_data(a6)
	
		cmp.b	#1,Db_type(a6)		* not ADPCM ?
		bcc	_not_adpcm
		 bsr	__mk_chain_table
		 bsr	__adpcm_play
		moveq	#0,d7
	bra	_pcm_play_end
	
	_not_adpcm:
		 bsr	__mercury_check
		tst.l	d0
		bmi	_pcm_play_err		* no unit
		beq	_v35			* V3.5 ?
		
	_v31:	cmp.b	#3,Db_rate(a6)		* over 32kHz ?
		bcc	2f
		cmp.b	#3,Db_type(a6)		* 16bit PCM ?
		bcc	1f
		 bsr	__8to16_22to44
		bra	3f
	
	1:	 bsr	__22to44
		bra	3f
		
	2:	cmp.b	#3,Db_type(a6)		* 16bit PCM ?
		bcc	3f
		 bsr	__8to16
		bra	3f
	
	_v35:	cmp.b	#3,Db_type(a6)		* 16bit PCM ?
		bcc	4f
		 bsr	__8to16
	3:	bmi	_pcm_play_err2		* no memory
	4:	 bsr	__mercury_init
		 bsr	__mk_chain_table
		 bsr	__pcm_play
		moveq	#0,d7
	bra	_pcm_play_end
	
	_pcm_play_err:
		moveq	#-1,d7
	bra	_pcm_play_end
	_pcm_play_err2:
		moveq	#-2,d7
	_pcm_play_end:
		movem.l	(sp)+,d0-d6/a0-a6
		rts



* ------------------------------
* Play 16bitPCM.
*
__pcm_play:
		lea	DMAC_CH2,a0
		move.w	#-1,(a0)			* CSR error clear
		move.b	#%0001_0000,7(a0)		* CCR
		*	  ^				* STR /1:start
		*	   ^				* CNT /1:continue use
		*	    ^				* HLT /1:halt
		*	     ^				* SAB /1:soft abort
		*	       ^			* INT /1:int enable
		move.w	#-1,(a0)			*  error clear
		move.b	#%1000_1000,4(a0)		* DCR
		*	       ^			*  16bit port
		move.b	#%0001_1110,5(a0)		* OCR
		*	    ^^				*  operand 16bit
		move.b	#%0000_0100,6(a0)		* SCR
		*	       ^^			*  memory count inc.
		move.l	#MERCURY_DATA,$14(a0)		* DAR
		move.l	#B_chain_table,$1c(a0)		* BAR .l
		
	@@:	btst.b	#0,(a0)				* dmac ch2 PCL
		beq	@b				* wait 'R'>'L' clock
	@@:	btst.b	#0,(a0)
		bne	@b				* wait 'L'>'R' clock
		move.b	#%1000_0000,7(a0)		* CCR
		rts



* ------------------------------
* 8bit to 16bit
* 22kHz to 44kHz
*
__8to16_22to44:
		moveq	#2,d7
		 bsr	__cv_malloc
		bmi	_cv_err
		bne	_cv_skip
		
		 bsr	__clr_buff
		
		movea.l	P_data(a6),a0
		movea.l	P_ex_buff(a6),a1
		move.l	a1,P_data(a6)			*
		move.l	D_length(a6),d7
		lsr.l	#5,d7
		
		btst	#0,Db_type(a6)			* STEREO ?
		beq	1f
		@@:	move.b	(a0)+,d0		* for MONO
			move.b	d0,(a1)
			move.b	d0,2(a1)
			move.b	(a0)+,d0
			move.b	d0,4(a1)
			move.b	d0,6(a1)
			move.b	(a0)+,d0
			move.b	d0,8(a1)
			move.b	d0,10(a1)
			move.b	(a0)+,d0
			move.b	d0,12(a1)
			move.b	d0,14(a1)
			move.b	(a0)+,d0
			move.b	d0,16(a1)
			move.b	d0,18(a1)
			move.b	(a0)+,d0
			move.b	d0,20(a1)
			move.b	d0,22(a1)
			move.b	(a0)+,d0
			move.b	d0,24(a1)
			move.b	d0,26(a1)
			move.b	(a0)+,d0
			move.b	d0,28(a1)
			move.b	d0,30(a1)
			lea	32(a1),a1
		subq.l	#1,d7
		bhi	@b
		moveq	#0,d0
		rts

		1:
		@@:	move.b	(a0)+,d0		* for STEREO
			move.b	d0,(a1)
			move.b	d0,4(a1)
			move.b	(a0)+,d0
			move.b	d0,2(a1)
			move.b	d0,6(a1)
			move.b	(a0)+,d0
			move.b	d0,8(a1)
			move.b	d0,12(a1)
			move.b	(a0)+,d0
			move.b	d0,10(a1)
			move.b	d0,14(a1)
			move.b	(a0)+,d0
			move.b	d0,16(a1)
			move.b	d0,20(a1)
			move.b	(a0)+,d0
			move.b	d0,18(a1)
			move.b	d0,22(a1)
			move.b	(a0)+,d0
			move.b	d0,24(a1)
			move.b	d0,28(a1)
			move.b	(a0)+,d0
			move.b	d0,26(a1)
			move.b	d0,30(a1)
			lea	32(a1),a1
		subq.l	#1,d7
		bhi	@b
		moveq	#0,d0
		rts



* ------------------------------
* 22kHz to 44kHz
*
__22to44:
		moveq	#1,d7
		 bsr	__cv_malloc
		bmi	_cv_err
		bne	_cv_skip
		
		movea.l	P_data(a6),a0
		movea.l	P_ex_buff(a6),a1
		move.l	a1,P_data(a6)			*
		move.l	D_length(a6),d7
		lsr.l	#4,d7
		
		btst	#0,Db_type(a6)			* STEREO ?
		beq	1f

		@@:	movem.w	(a0)+,d0-d6/a2		* for MONO
			move.w	d0,(a1)+
			move.w	d0,(a1)+
			move.w	d1,(a1)+
			move.w	d1,(a1)+
			move.w	d2,(a1)+
			move.w	d2,(a1)+
			move.w	d3,(a1)+
			move.w	d3,(a1)+
			move.w	d4,(a1)+
			move.w	d4,(a1)+
			move.w	d5,(a1)+
			move.w	d5,(a1)+
			move.w	d6,(a1)+
			move.w	d6,(a1)+
			move.w	a2,(a1)+
			move.w	a2,(a1)+
		subq.l	#1,d7
		bhi	@b
		moveq	#0,d0
		rts

		1:
		@@:	movem.l	(a0)+,d0-d3		* for STEREO
			move.l	d0,(a1)+
			move.l	d0,(a1)+
			move.l	d1,(a1)+
			move.l	d1,(a1)+
			move.l	d2,(a1)+
			move.l	d2,(a1)+
			move.l	d3,(a1)+
			move.l	d3,(a1)+
		subq.l	#1,d7
		bhi	@b
		moveq	#0,d0
		rts



* ------------------------------
* 8bit to 16bit
*
__8to16:
		moveq	#1,d7
		 bsr	__cv_malloc
		bmi	_cv_err
		bne	_cv_skip
		
		 bsr	__clr_buff
		
		movea.l	P_data(a6),a0
		movea.l	P_ex_buff(a6),a1
		move.l	a1,P_data(a6)			*
		move.l	D_length(a6),d7
		lsr.l	#6,d7
		@@:	movem.l	(a0)+,d0-d3
			movep.l	d0,0(a1)
			movep.l	d1,8(a1)
			movep.l	d2,16(a1)
			movep.l	d3,24(a1)
			movem.l	(a0)+,d0-d3
			movep.l	d0,32(a1)
			movep.l	d1,40(a1)
			movep.l	d2,48(a1)
			movep.l	d3,56(a1)
			lea	64(a1),a1
		subq.l	#1,d7
		bhi	@b
		
	_cv_skip:
		moveq	#0,d0
	_cv_err:
		rts


	__clr_buff:
		movea.l	P_ex_buff(a6),a0
		move.l	D_length(a6),d7
		lsr.l	#5,d7
		@@:	clr.l	(a0)+
			clr.l	(a0)+
			clr.l	(a0)+
			clr.l	(a0)+
			clr.l	(a0)+
			clr.l	(a0)+
			clr.l	(a0)+
			clr.l	(a0)+
		subq.l	#1,d7
		bhi	@b
		rts

	__cv_malloc:
		move.l	P_data(a6),d0
		move.b	Db_type(a6),d1
		move.b	Db_rate(a6),d2
		cmp.l	P_last_data(a6),d0
		bne	1f
		cmp.b	Db_last_type(a6),d1
		bne	1f
		cmp.b	Db_last_rate(a6),d2
		beq	4f
	1:	move.l	d0,P_last_data(a6)		*
		move.b	d1,Db_last_type(a6)		*
		move.b	d2,Db_last_rate(a6)		*
	
		tst.l	P_ex_buff(a6)
		beq	2f
		move.l	P_ex_buff(a6),-(sp)
		.dc.w	$ff49				* DOS _MFREE
		addq	#4,sp
	2:
		move.l	D_length(a6),d0
		lsl.l	d7,d0
		move.l	d0,D_length(a6)			*
		ori.l	#$ff,d0
		addq.l	#1,d0
		move.l	d0,-(sp)
		.dc.w	$ff48				* DOS _MALLOC
		addq	#4,sp
		move.l	d0,P_ex_buff(a6)
		bmi	3f
		moveq	#0,d0
	3:	rts

	4:	move.l	P_ex_buff(a6),d0
		move.l	d0,P_data(a6)			*
		move.l	D_length(a6),d0
		lsl.l	d7,d0
		move.l	d0,D_length(a6)			*
		moveq	#1,d0
		rts



* ------------------------------
* Make chain table. for 16bit
*
__mk_chain_table:
		move.l	P_data(a6),d0
		move.l	D_length(a6),d1
		lea	B_chain_table,a1
		cmp.b	#1,Db_type(a6)			* 16bit PCM ?
		bcc	2f
		
		1:	move.l	d0,(a1)+
			add.l	#$fffc,d0
			move.w	#$fffc,(a1)+
			move.l	a1,(a1)
			add.l	#4,(a1)+
		sub.l	#$fffc,d1
		bgt	1b
		add.l	#$fffc,d1
		move.w	d1,-6(a1)
		bra	3f
		
		2:	move.l	d0,(a1)+
			add.l	#$fffc*2,d0
			move.w	#$fffc,(a1)+
			move.l	a1,(a1)
			add.l	#4,(a1)+
		sub.l	#$fffc*2,d1
		bgt	2b
		add.l	#$fffc*2,d1
		lsr.l	#1,d1
		move.w	d1,-6(a1)

	3:	moveq	#0,d0
		tst.b	Db_loop(a6)			* loop mode ?
		beq	@f
		move.l	#B_chain_table,d0
	@@:	move.l	d0,-(a1)
		rts



* ------------------------------
* Set Mercury-Unit command port.
*
__mercury_init:
		lea	DMAC_CH2,a0
		move.w	#-1,(a0)
		move.b	#%0001_0000,7(a0)	* soft abort
		
		move.b	#%1001_0011,MERCURY_COMMAND
						* gate off
		
	@@:	btst.b	#0,(a0)
		beq	@b
		clr.w	MERCURY_DATA		* output Lch zero
	@@:	btst.b	#0,(a0)
		bne	@b
		clr.w	MERCURY_DATA		* output Rch zero
		
		moveq	#0,d0
		move.b	Db_rate(a6),d0
		move.b	T_unit_com(pc,d0.w),d1	* CLOCK SELECT
		move.b	Db_pan(a6),d0
		lsl.b	#2,d0
		andi.b	#%1100,d0
		or.b	d0,d1			* PANPOT
		btst	#0,Db_type(a6)
		beq	@f
		bclr	#1,d1			* STEREO/MONO
	@@:	move.b	d1,MERCURY_COMMAND
		rts

T_unit_com:	.dc.b	%0001_0011		* 16kHz stereo
		.dc.b	%0010_0011		* 22kHz
		.dc.b	%0011_0011		* 24kHz
		.dc.b	%1001_0011		* 32kHz
		.dc.b	%1010_0011		* 44kHz
		.dc.b	%1011_0011		* 48kHz
		.even
		*	 ^			MASTER CLOCK  0:low / 1:high   (V3.5)
		*	  ^			INPUT SELECT  0:optical / 1:corexial
		*	   ^^			CLOCK SELECT  00: BCKex / 01-11: BCKint
		*	      ^^		PANPOT RG,LG
		*		^		STEREO/MONO
		*		 ^		OUT/IN


* ------------------------------
* Check Mercury-Unit
*
*	output	d0.l : -1(no unit), 0(V3.5`), 1(`V3.1)
*
__mercury_check:
		movem.l	a0-a1,-(sp)
		moveq	#-1,d0
		movea.l	a7,a0
		movea.l	8.w,a1
		move.l	#1f,8.w			* bus error vector
		tst.b	MERCURY_STATUS		* bus error > 1f
		move.l	a1,8.w
		move.b	#%0101_0011,MERCURY_COMMAND
		btst	#6,MERCURY_STATUS
		beq	2f
		move.b	#%0001_0011,MERCURY_COMMAND
		btst	#6,MERCURY_STATUS
		bne	2f
		moveq	#0,d0
		btst	#7,MERCURY_STATUS
		beq	2f
		moveq	#1,d0
		bra	2f
		
	1:	movea.l	a0,a7
		move.l	a1,8.w
	2:	movem.l	(sp)+,a0-a1
		rts


* ------------------------------
* Play ADPCM.
*
__adpcm_play:
		moveq	#$67,d0
		moveq	#0,d1
		trap	#15			* IOCS _ADPCMMOD
	
		moveq	#$64,d0
		move.w	Db_rate(a6),d1
		lea	B_chain_table,a1
		trap	#15			* IOCS _ADPCMLOT
		rts


* ------------------------------------------------------------
* PCM~
*
*	input	d0.l : ----
*		d1.l : ----
*		d7.l : ----
*	output	d7.l : ----
*
_pcm_stop:
		movem.l	d0-d7/a0,-(sp)
		lea	DMAC_CH2,a0
		move.w	#-1,(a0)
		move.b	#%0001_0000,7(a0)	* soft abort
		move.w	#-1,(a0)
	
		moveq	#$67,d0
		moveq	#0,d1
		trap	#15			* IOCS _ADPCMMOD
		movem.l	(sp)+,d0-d7/a0
		rts


* ------------------------------------------------------------
* PCM~
*
*	input	d0.l : ----
*		d1.l : ----
*		d7.l : ----
*	output	d7.l : ----
*
_pcm_loop_stop:
		move.l	a0,-(sp)
		lea	B_chain_table,a0
		move.l	#D_pcm_end,(a0)+
		move.w	#1,(a0)+
		clr.l	(a0)
		move.l	(sp)+,a0
		rts

D_pcm_end:	.dc.b	$80,$80


* ------------------------------------------------------------
* Mercury-Unit check
*
*	input	d0.l : ----
*		d1.l : ----
*		d7.l : ----
*	output	d7.l : -1(no unit), 0(V3.5`), 1(`V3.1)
*
_mercury_check:
		movem.l	d0-d6/a0-a6,-(sp)
		 bsr	__mercury_check
		move.l	d0,d7
		movem.l	(sp)+,d0-d6/a0-a6
		rts


		.data
B_chain_table::	.dcb.w	128*5,0
		.text
* ------------------------------------------------------------


		.end
